#include<bits/stdc++.h>
#define xx first
#define yy second
#define pb push_back

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

int n, q, par[1010], sz[1010], niz[1010];
bool ok, jeste;
vector<pair<pii, pii>> kv;
set<int> parni, neparni;
int fnd(int a) {
    if(a==par[a]) return a;
    return par[a]=fnd(par[a]);
}
void merg(int a, int b) {
    a=fnd(a); b=fnd(b);
    if(sz[a]<sz[b]) swap(a, b);
    par[b]=a;
    sz[a]+=sz[b];
}
bool prob(int a, int sa, int b, int sb, int aa, int bb) {
    if(niz[a]!=niz[b] || niz[a]==0 || niz[b]==0 || (sa==1 && sb==-1)) return false;
    if(a+(sa==1?1:0)==aa && b+(sb==1?1:0)==bb) return true;
    return max(max(prob(a+sa, sa, b+sb, sb, aa, bb), prob(a, -sa, b+sb, sb, aa, bb)), prob(a+sa, sa, b, -sb, aa, bb));
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> q;
    ok=jeste=1;
    for(int i=1; i<=q; i++) {
        int t, u, v;
        char c;
        cin >> t >> u >> v;
        if(t==1) {
            cin >> c;
            if(v-u!=1) jeste=0;
            if(c!='a') ok=0;
        }
        kv.pb({{t, u}, {v, (t==1?c-'a':0)}});
    }
    if(ok) {
        for(int i=1; i<=n; i++) {
            par[i]=i;
            sz[i]=1;
        }
        for(auto x:kv) {
            if(x.xx.xx==1) {
                merg(x.xx.yy, x.yy.xx);
            }
            else {
                if(fnd(x.xx.yy)==fnd(x.yy.xx)) cout << 1;
                else cout << 0;
                cout << "\n";
            }
        }
    }
    else if(jeste) {
        for(auto x:kv) {
            if(x.xx.xx==1) {
                if(niz[x.xx.yy]==x.yy.yy+1) continue;
                if(niz[x.xx.yy]==niz[x.xx.yy+2] && niz[x.xx.yy]!=0) {
                    auto it=neparni.find(x.xx.yy+1);
                    neparni.erase(it);
                }
                if(x.xx.yy-2>=1 && niz[x.xx.yy]==niz[x.xx.yy-2] && niz[x.xx.yy]!=0) {
                    auto it=neparni.find(x.xx.yy-1);
                    neparni.erase(it);
                }
                if(niz[x.xx.yy]==niz[x.xx.yy+1] && niz[x.xx.yy]!=0) {
                    auto it=parni.find(x.xx.yy);
                    parni.erase(it);
                }
                if(x.xx.yy-1>=1 && niz[x.xx.yy]==niz[x.xx.yy-1] && niz[x.xx.yy]!=0) {
                    auto it=parni.find(x.xx.yy-1);
                    parni.erase(it);
                }
                niz[x.xx.yy]=x.yy.yy+1;
                if(niz[x.xx.yy]==niz[x.xx.yy+2]) neparni.insert(x.xx.yy+1);
                if(x.xx.yy-2>=1 && niz[x.xx.yy]==niz[x.xx.yy-2]) neparni.insert(x.xx.yy-1);
                if(niz[x.xx.yy]==niz[x.xx.yy+1]) parni.insert(x.xx.yy);
                if(x.xx.yy-1>=1 && niz[x.xx.yy]==niz[x.xx.yy-1]) parni.insert(x.xx.yy-1);
            }
            else {
                int mini=min(x.xx.yy, x.yy.xx), maxi=max(x.xx.yy, x.yy.xx);
                if((maxi-mini)%2==0) {
                    bool ock=0;
                    for(auto it=parni.lower_bound(mini); it!=parni.end(); it++) {
                        int i=*it;
                        if(i<mini) continue;
                        if(i>=maxi) break;
                        if(prob(i, -1, i+1, 1, mini, maxi)) {
                            ock=1;
                            break;
                        }
                    }
                    cout << ock;
                }
                else if(maxi-mini==1) {
                    cout << 1;
                }
                else {
                    bool ock=0;
                    for(auto it=neparni.lower_bound(mini); it!=neparni.end(); it++) {
                        int i=*it;
                        if(i<mini) continue;
                        if(i>=maxi) break;
                        if(prob(i, -1, i, 1, mini, maxi)) {
                            ock=1;
                            break;
                        }
                    }
                    cout << ock;
                }
                cout << "\n";
            }
        }
    }
    return 0;
}